diff --git a/libglusterfs/src/dict.c b/libglusterfs/src/dict.c
index c2f04f7b574..30e007d4b9b 100644
--- a/libglusterfs/src/dict.c
+++ b/libglusterfs/src/dict.c
@@ -1570,9 +1570,19 @@ dict_get_with_refn(dict_t *this, char *key, const int keylen, data_t **data)
 int
 dict_get_with_ref(dict_t *this, char *key, data_t **data)
 {
-    if (!this || !key || !data) {
+    if (!this) {
+        /* There are possibilities where dict can be NULL. so not so critical
+         * for users to know */
+        gf_msg_callingfn("dict", GF_LOG_DEBUG, EINVAL, LG_MSG_INVALID_ARG,
+                         "dict is NULL: %s", key);
+        return -EINVAL;
+    }
+    if (!key || !data) {
+        /* is there a chance like this? then it can be a coding error, but in
+         * any case, this should be caught early, so good to log it out. */
         gf_msg_callingfn("dict", GF_LOG_WARNING, EINVAL, LG_MSG_INVALID_ARG,
-                         "dict OR key (%s) is NULL", key);
+                         "key (%s) or data ptr is NULL", key);
+
         return -EINVAL;
     }
 #if !DICT_LIST_IMP
